## mathic 1.0~git20181123

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(mathic VERSION 1.0 LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

add_library(mathic
  src/mathic/Action.cpp
  src/mathic/BitTriangle.cpp
  src/mathic/BoolParameter.cpp
  src/mathic/CliParameter.cpp
  src/mathic/CliParser.cpp
  src/mathic/ColumnPrinter.cpp
  src/mathic/DivMask.cpp
  src/mathic/HelpAction.cpp
  src/mathic/IntegerParameter.cpp
  src/mathic/StringParameter.cpp
  src/mathic/Timer.cpp
  src/mathic/display.cpp
  src/mathic/error.cpp
  src/mathic/BinaryKDTree.h
  )

target_link_libraries(mathic memtailor)
target_include_directories(mathic
  PUBLIC
    src
    )
  
install(TARGETS mathic ARCHIVE DESTINATION lib)
install(FILES include/mathic.h DESTINATION include)
install(DIRECTORY src/mathic/
  DESTINATION include/mathic
  FILES_MATCHING PATTERN "*.h"
  PATTERN stdinc.h EXCLUDE
  )

add_executable(pqsim
  src/pqsim/pqMain.h         src/pqsim/pqMain.cpp
  src/pqsim/Item.h           src/pqsim/Item.cpp
  src/pqsim/Model.h          src/pqsim/Model.cpp
  src/pqsim/Simulator.h      src/pqsim/Simulator.cpp
  src/pqsim/GeobucketModel.h
  src/pqsim/HeapModel.h
  src/pqsim/StlSetModel.h
  src/pqsim/TourTreeModel.h
  src/pqsim/stdinc.h
  )
add_executable(divsim
  src/divsim/divMain.h       src/divsim/divMain.cpp 
  src/divsim/Simulation.h    src/divsim/Simulation.cpp
  src/divsim/DivListModel.h
  src/divsim/KDTreeModel.h
  src/divsim/Monomial.h
  src/divsim/stdinc.h
  )
target_link_libraries(pqsim mathic)
target_link_libraries(divsim mathic)

option(PACKAGE_TESTS "Build the tests" ON)
if(PACKAGE_TESTS)
  enable_testing()
  add_executable(mathic-gtests
    src/test/BitTriangle.cpp
    src/test/DivFinder.cpp
    src/test/HashTable.cpp
    src/test/PairQueue.cpp
    src/test/gtestInclude.cpp
    src/test/testMain.cpp
    )
  target_link_libraries(mathic-gtests mathic)
  endif()

################################
# add gtest testing ############
################################

include(FetchContent)

FetchContent_Declare(
  googletest
  GIT_REPOSITORY https://github.com/google/googletest.git
  GIT_TAG        release-1.8.0
)

FetchContent_GetProperties(googletest)
if(NOT googletest_POPULATED)
  FetchContent_Populate(googletest)
endif()

target_include_directories(mathic-gtests
  PRIVATE
  ${googletest_SOURCE_DIR}/googletest/include
  ${googletest_SOURCE_DIR}/googletest/src
  ${googletest_SOURCE_DIR}/googletest
  )

add_test(NAME mathic-gtests
      COMMAND mathic-gtests
  )

## mathic 1.0~git20130827

=== debian/changelog ===
mathic (1.0~git20130827-3) unstable; urgency=medium

  * debian/{control,libmathic0.install}
    - Rename libmathic0 to libmathic0v5 for libstdc++ transition
      (Closes: #797983).
  * debian/control
    - Add libmathic0 to Breaks/Replaces.

 -- Doug Torrance <dtorrance@piedmont.edu>  Sun, 06 Sep 2015 02:31:53 -0400

mathic (1.0~git20130827-2) unstable; urgency=medium

  * Update my email address.
  * debian/control
    - Remove dpkg-dev (>= 1.18.0) from Build-Depends; unnecessary as we have
      removed the symbols file.
  * debian/libmathic0.symbols
    - Remove file for ease of maintainability.

 -- Doug Torrance <dtorrance@piedmont.edu>  Sat, 29 Aug 2015 09:42:23 -0400

mathic (1.0~git20130827-1) unstable; urgency=low

  * Initial release (Closes: #780783).

 -- Doug Torrance <dtorrance@monmouthcollege.edu>  Wed, 01 Apr 2015 06:27:19 -0500

=== debian/control ===
Source: mathic
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Doug Torrance <dtorrance@piedmont.edu>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 9),
               dh-autoreconf,
               libgtest-dev,
               libmemtailor-dev,
               pkg-config
Standards-Version: 3.9.6
Vcs-Browser: http://anonscm.debian.org/cgit/debian-science/packages/mathic.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/mathic.git
Homepage: https://github.com/broune/mathic

Package: libmathic-dev
Architecture: any
Section: libdevel
Depends: libmathic0v5 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: C++ library for Groebner basis computation (developer tools)
 Mathic is a C++ library of fast data structures designed for use in Groebner
 basis computation. This includes data structures for ordering S-pairs,
 performing divisor queries and ordering polynomial terms during polynomial
 reduction.
 .
 This package contains the developer tools.

Package: libmathic0v5
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Breaks: libmathic0
Replaces: libmathic0
Multi-Arch: same
Description: C++ library for Groebner basis computation (runtime library)
 Mathic is a C++ library of fast data structures designed for use in Groebner
 basis computation. This includes data structures for ordering S-pairs,
 performing divisor queries and ordering polynomial terms during polynomial
 reduction.
 .
 This package contains the runtime library.

Package: libmathic-dbg
Architecture: any
Section: debug
Priority: extra
Depends: libmathic0v5 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: C++ library for Groebner basis computation (debugging symbols)
 Mathic is a C++ library of fast data structures designed for use in Groebner
 basis computation. This includes data structures for ordering S-pairs,
 performing divisor queries and ordering polynomial terms during polynomial
 reduction.
 .
 This package contains the debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- GTEST_PATH=/usr/src

override_dh_strip:
	dh_strip --dbg-package=libmathic-dbg

get-orig-source:
	wget https://github.com/broune/mathic/archive/master.tar.gz
	git checkout upstream
	git pull https://github.com/broune/mathic
	grep -Po '(?<=AC_INIT\(\[mathic\], \[).*(?=\]\))' configure.ac \
		> version
	git show HEAD^:configure.ac | \
		grep -Po '(?<=AC_INIT\(\[mathic\], \[).*(?=\]\))' > oldversion
	if test `cat oldversion` = `cat version` ; then \
		echo "`cat version`~git`date -d @\`git log -1 --pretty=format:%ct\` +%Y%m%d`" > version; \
	fi
	git checkout master
	mv -v master.tar.gz ../mathic_`cat version`.orig.tar.gz
	rm version oldversion

=== debian/watch ===
# Upstream does not currently tag their releases.  However, if they do in the
# future, something similar to the following should work.
# version=3
# https://github.com/broune/mathic/tags \
# /broune/mathic/archive/mathic-(.+)\.tar\.gz

## mathic 1.0~git20160320

=== debian/changelog ===
mathic (1.0~git20160320-4) unstable; urgency=medium

  * debian/control
    - Bump Standards-Version to 3.9.8.
  * debian/libmathic0v5.symbols
    - Add optional tags to symbols missing when compiled with gcc-6
      (Closes: #831109).

 -- Doug Torrance <dtorrance@piedmont.edu>  Fri, 15 Jul 2016 12:36:02 -0400

mathic (1.0~git20160320-3) unstable; urgency=medium

  * debian/libmathic0v5.symbols
    - Mark additional symbols optional that are optimized away at -O3.
      Thanks to Steve Langasek <steve.langasek@ubuntu.com> (Closes: #830811).

 -- Doug Torrance <dtorrance@piedmont.edu>  Tue, 12 Jul 2016 00:32:16 -0400

mathic (1.0~git20160320-2) unstable; urgency=medium

  * debian/libmathic0v5.symbols
    - Add some arch-specific tags to fix FTBFS.
  * debian/patches/fix_typo.patch
    - Switch Forwarded to Applied-Upstream.

 -- Doug Torrance <dtorrance@piedmont.edu>  Fri, 25 Mar 2016 20:49:52 -0400

mathic (1.0~git20160320-1) unstable; urgency=medium

  * New upstream release.
    - Now maintained by Macaulay2 developers.
  * debian/control
    - Bump versioned dependency on debhelper to >= 9.20160114.  Needed for
      --dbgsym-migration option to dh_strip.
    - Bump Standards-Version to 3.9.7.
    - Update Homepage.
    - Use https protocol for Vcs-Browser.
    - Drop libmathic-dgb in favor of automatically generated
      libmathic0v5-dbgsym package.
  * debian/copyright
    - Update Source.
    - Change license to LGPL-2+. (This has actually always been the license;
      I must have misread it when initially preparing the package.)
  * debian/libmathic0v5.symbols
    - Restore symbols file.
  * debian/patches
    - Remove previous patches; patches applied upstream.
  * debian/patches/fix_typo.patch
    - New patch. Fixes spelling-error-in-binary Lintian warning.
  * debian/rules
    - Enable all hardening flags.
    - Update definition of GTEST_PATH for dh_auto_configure.
    - Add --enable-shared to dh_auto_configure.
    - Modify override_dh_strip target. Instead of building the libmathic-dbg
      package, we use the --dbgsym-migration option to ensure proper migration
      to the new automatically generated package.
    - Update get-orig-source target with new location.
  * debian/watch
    - Update with new upstream webpage. Note that this is merely a comment;
      upstream does not tag their releases and uscan is currently not
      functional.

 -- Doug Torrance <dtorrance@piedmont.edu>  Sun, 20 Mar 2016 16:54:38 -0400

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,15 @@
 Uploaders: Doug Torrance <dtorrance@piedmont.edu>
 Section: libs
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 9.20160114),
                dh-autoreconf,
                libgtest-dev,
                libmemtailor-dev,
                pkg-config
-Standards-Version: 3.9.6
-Vcs-Browser: http://anonscm.debian.org/cgit/debian-science/packages/mathic.git
+Standards-Version: 3.9.8
+Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/mathic.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/mathic.git
-Homepage: https://github.com/broune/mathic
+Homepage: https://github.com/Macaulay2/mathic
 
 Package: libmathic-dev
 Architecture: any
@@ -40,17 +40,3 @@
  reduction.
  .
  This package contains the runtime library.
-
-Package: libmathic-dbg
-Architecture: any
-Section: debug
-Priority: extra
-Depends: libmathic0v5 (= ${binary:Version}), ${misc:Depends}
-Multi-Arch: same
-Description: C++ library for Groebner basis computation (debugging symbols)
- Mathic is a C++ library of fast data structures designed for use in Groebner
- basis computation. This includes data structures for ordering S-pairs,
- performing divisor queries and ordering polynomial terms during polynomial
- reduction.
- .
- This package contains the debugging symbols.

=== debian/rules ===
--- 
+++ 
@@ -1,18 +1,20 @@
 #!/usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
 	dh $@ --with autoreconf
 
 override_dh_auto_configure:
-	dh_auto_configure -- GTEST_PATH=/usr/src
+	dh_auto_configure -- GTEST_PATH=/usr/src/gtest --enable-shared
 
 override_dh_strip:
-	dh_strip --dbg-package=libmathic-dbg
+	dh_strip --dbgsym-migration='libmathic-dbg (<< 1.0~git20160320-1~)'
 
 get-orig-source:
-	wget https://github.com/broune/mathic/archive/master.tar.gz
+	wget https://github.com/Macaulay2/mathic/archive/master.tar.gz
 	git checkout upstream
-	git pull https://github.com/broune/mathic
+	git pull https://github.com/Macaulay2/mathic
 	grep -Po '(?<=AC_INIT\(\[mathic\], \[).*(?=\]\))' configure.ac \
 		> version
 	git show HEAD^:configure.ac | \

## mathic 1.0~git20170606

=== debian/changelog ===
mathic (1.0~git20170606-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/control
    - Bump Standards-Version to 4.0.1.
    - Bump versioned dependency on debhelper to >= 10.
    - Remove Build-Depends on dh-autoreconf.
  * debian/compat
    - Bump debhelper compatibility level to 10.
  * debian/copyright
    - Use https in Format.
  * debian/libmathic0v5.symbols
    - Remove file for ease of maintainability (Closes: #853540).
  * debian/patches/fix_typo.patch
    - Remove patch; applied upstrem.
  * debian/rules
    - Remove call to dh_autoreconf; enabled by default with debhelper 10.
    - New override_dh_makeshlibs target.  Generates tightest possible
      dependency.

 -- Doug Torrance <dtorrance@piedmont.edu>  Sat, 12 Aug 2017 16:53:20 -0400

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,11 @@
 Uploaders: Doug Torrance <dtorrance@piedmont.edu>
 Section: libs
 Priority: optional
-Build-Depends: debhelper (>= 9.20160114),
-               dh-autoreconf,
+Build-Depends: debhelper (>= 10),
                libgtest-dev,
                libmemtailor-dev,
                pkg-config
-Standards-Version: 3.9.8
+Standards-Version: 4.0.1
 Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/mathic.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/mathic.git
 Homepage: https://github.com/Macaulay2/mathic

=== debian/rules ===
--- 
+++ 
@@ -3,13 +3,16 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
-	dh $@ --with autoreconf
+	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- GTEST_PATH=/usr/src/gtest --enable-shared
 
 override_dh_strip:
 	dh_strip --dbgsym-migration='libmathic-dbg (<< 1.0~git20160320-1~)'
+
+override_dh_makeshlibs:
+	dh_makeshlibs -V
 
 get-orig-source:
 	wget https://github.com/Macaulay2/mathic/archive/master.tar.gz

=== debian/tests/control ===
Tests: build
Depends: build-essential, libmathic-dev, libmemtailor-dev, pkg-config

=== debian/watch ===
# Upstream does not currently tag their releases.  However, if they do in the
# future, something similar to the following should work.
# version=3
# https://github.com/Macaulay2/mathic/tags \
# /Macaulay2/mathic/archive/mathic-(.+)\.tar\.gz

## mathic 1.0~git20180311

=== debian/changelog ===
mathic (1.0~git20180311-2) unstable; urgency=medium

  * debian/tests/control
    - Add build-essential and libgtest-dev to Depends (Closes: #903720).

 -- Doug Torrance <dtorrance@piedmont.edu>  Fri, 13 Jul 2018 13:58:13 -0400

mathic (1.0~git20180311-1) unstable; urgency=medium

  * debian/compat
    - Bump debhelper compatibility level to 11.
  * debian/control
    - Bump versioned dependency on debhelper to >= 11.
    - Bump Standards-Version to 4.1.5.
    - Update Vcs-* links to Salsa.
  * debian/rules
    - Drop get-orig-source target: replaced by uscan.
  * debian/tests
    - Replace smoke test with upstream unit tests.
  * debian/upstream/metadata
    - New file; add DEP-12 upstream metadata.
  * debian/watch
    - Use uscan with git mode to obtain upstream tarball.

 -- Doug Torrance <dtorrance@piedmont.edu>  Mon, 09 Jul 2018 21:53:42 -0400

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,13 @@
 Uploaders: Doug Torrance <dtorrance@piedmont.edu>
 Section: libs
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 11),
                libgtest-dev,
                libmemtailor-dev,
                pkg-config
-Standards-Version: 4.0.1
-Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/mathic.git
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/mathic.git
+Standards-Version: 4.1.5
+Vcs-Browser: https://salsa.debian.org/science-team/mathic
+Vcs-Git: https://salsa.debian.org/science-team/mathic.git
 Homepage: https://github.com/Macaulay2/mathic
 
 Package: libmathic-dev

=== debian/tests/control ===
Tests: unittest
Depends: @, build-essential, libgtest-dev, libmemtailor-dev, pkg-config

## mathic 1.0~git20181123

=== debian/changelog ===
mathic (1.0~git20181123-1ubuntu1) focal; urgency=medium

  * Merge from Debian unstable, remaining changes:
    + Allow stderr output in autopkgtests for GCC warnings on armhf

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 12 Apr 2020 08:07:49 +0000

mathic (1.0~git20181123-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/compat
    - Drop file; no longer necessary since we build-depend on
      debhelper-compat.
  * debian/control
    - Switch Build-Depend on debhelper to debhelper-compat, specifying
      compatibility level 12.
    - Bump Standards-Version to 4.4.1.
  * debian/patches/cross.patch
    - New patch; use test -e instead of AC_CHECK_FILE to enable cross
      building.  Thanks to Helmut Grohne <helmut@subdivi.de> for the patch
      (Closes: #948146).

 -- Doug Torrance <dtorrance@piedmont.edu>  Mon, 13 Jan 2020 11:08:12 -0500

mathic (1.0~git20180311-2ubuntu1) cosmic; urgency=medium

  * Allow stderr output in autopkgtests for GCC warnings on armhf

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 14 Jul 2018 18:24:25 +0000

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: mathic
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Doug Torrance <dtorrance@piedmont.edu>
 Section: libs
 Priority: optional
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 12),
                libgtest-dev,
                libmemtailor-dev,
                pkg-config
-Standards-Version: 4.1.5
+Standards-Version: 4.4.1
 Vcs-Browser: https://salsa.debian.org/science-team/mathic
 Vcs-Git: https://salsa.debian.org/science-team/mathic.git
 Homepage: https://github.com/Macaulay2/mathic

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- GTEST_PATH=/usr/src/gtest --enable-shared

override_dh_strip:
	dh_strip --dbgsym-migration='libmathic-dbg (<< 1.0~git20160320-1~)'

override_dh_makeshlibs:
	dh_makeshlibs -V

## mathic 1.0~git20200526

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

project(mathic VERSION 1.0 LANGUAGES CXX)

option(enable_pqsim "Build pqsim" OFF)
option(enable_divsim "Build divsim" OFF)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

find_package(Threads 2.1 REQUIRED QUIET)
find_package(Memtailor   REQUIRED)

add_compile_options(
  -DPACKAGE_NAME="${PROJECT_NAME}"
  -DPACKAGE_TARNAME="${PROJECT_NAME}"
  -DPACKAGE_VERSION="${PROJECT_VERSION}"
  -DPACKAGE_STRING="${PROJECT_NAME} ${PROJECT_VERSION}"
  -DPACKAGE_BUGREPORT=""
  -DPACKAGE_URL=""
  -DPACKAGE="${PROJECT_NAME}"
  -DVERSION="${PROJECT_VERSION}"
  )

add_library(mathic STATIC
  src/mathic.h
  src/mathic.cpp
  src/mathic/Action.cpp
  src/mathic/BitTriangle.cpp
  src/mathic/BoolParameter.cpp
  src/mathic/CliParameter.cpp
  src/mathic/CliParser.cpp
  src/mathic/ColumnPrinter.cpp
  src/mathic/DivMask.cpp
  src/mathic/HelpAction.cpp
  src/mathic/IntegerParameter.cpp
  src/mathic/StringParameter.cpp
  src/mathic/Timer.cpp
  src/mathic/display.cpp
  src/mathic/error.cpp
  src/mathic/BinaryKDTree.h
  src/mathic/stdinc.h
  )

target_link_libraries(mathic ${MEMTAILOR_LIBRARIES} Threads::Threads)
target_include_directories(mathic
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:include>
    ${MEMTAILOR_INCLUDE_DIR}
  )
set_target_properties(mathic PROPERTIES PUBLIC_HEADER src/mathic.h)

install(TARGETS mathic LIBRARY DESTINATION lib)
install(DIRECTORY src/mathic
  DESTINATION include
  FILES_MATCHING PATTERN "*.h"
  )
install(FILES README.md lgpl-2.0.txt lgpl-2.1.txt lgpl-3.0.txt
  DESTINATION licenses/mathic
  )

if(enable_pqsim)
add_executable(pqsim
  src/pqsim/pqMain.h         src/pqsim/pqMain.cpp
  src/pqsim/Item.h           src/pqsim/Item.cpp
  src/pqsim/Model.h          src/pqsim/Model.cpp
  src/pqsim/Simulator.h      src/pqsim/Simulator.cpp
  src/pqsim/GeobucketModel.h
  src/pqsim/HeapModel.h
  src/pqsim/StlSetModel.h
  src/pqsim/TourTreeModel.h
  src/pqsim/stdinc.h
  )
target_link_libraries(pqsim mathic)
endif()

if(enable_divsim)
add_executable(divsim
  src/divsim/divMain.h       src/divsim/divMain.cpp 
  src/divsim/Simulation.h    src/divsim/Simulation.cpp
  src/divsim/DivListModel.h
  src/divsim/KDTreeModel.h
  src/divsim/Monomial.h
  src/divsim/stdinc.h
  )
target_link_libraries(divsim mathic)
endif()

include(CTest)
if(BUILD_TESTING)
  add_executable(mathic-gtests
    src/test/BitTriangle.cpp
    src/test/DivFinder.cpp
    src/test/HashTable.cpp
    src/test/PairQueue.cpp
    src/test/testMain.cpp
    )

  ################################
  # add gtest testing ############
  ################################
  find_package(GTest)
  include(GoogleTest)
  gtest_discover_tests(mathic-gtests)

  if(GTEST_FOUND)
    target_link_libraries(mathic-gtests mathic GTest::GTest GTest::Main)
    target_include_directories(mathic-gtests PRIVATE ${GTEST_INCLUDE_DIR})
  else()
    include(FetchContent)
    FetchContent_Declare(googletest
      GIT_REPOSITORY https://github.com/google/googletest.git
      GIT_TAG        release-1.10.0
      )
    FetchContent_MakeAvailable(googletest)

    target_link_libraries(mathic-gtests mathic gtest)
    target_include_directories(mathic-gtests PRIVATE
      ${googletest_SOURCE_DIR}/googletest/include
      ${googletest_SOURCE_DIR}/googletest/src
      ${googletest_SOURCE_DIR}/googletest
      )
  endif()
endif()

=== debian/changelog ===
mathic (1.0~git20200526-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/control
    - Bump to debhelper compatibility level 13.
    - Bump Standards-Version to 4.5.0.
    - Add Rules-Requires-Root field.
  * debian/patches
    - Remove directory; only patch has been applied upstream.
  * debian/not-installed
    - Tell dh_missing that we aren't installing .la file.
  * debian/rules
    - Remove override_dh_strip argument passing --dbgsym-migration
      argument; automatic debug symbol package is now in oldstable.
    - Remove override_dh_makeshlibs target; it was passing the -V
      option, which is now the default after debhelper 12.
  * debian/salsa-ci.yml
    - Add Salsa pipelines config file.
  * debian/tests/control
    - Allow stderr output in autopkgtests for GCC warnings on armhf.
      Patch from Ubuntu package by Graham Inggs <ginggs@ubuntu.com>.

 -- Doug Torrance <dtorrance@piedmont.edu>  Wed, 01 Jul 2020 08:00:53 -0400

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,17 @@
 Source: mathic
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Doug Torrance <dtorrance@piedmont.edu>
 Section: libs
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                libgtest-dev,
                libmemtailor-dev,
                pkg-config
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/science-team/mathic
 Vcs-Git: https://salsa.debian.org/science-team/mathic.git
 Homepage: https://github.com/Macaulay2/mathic
+Rules-Requires-Root: no
 
 Package: libmathic-dev
 Architecture: any

## mathic 1.0~git20211001

=== debian/changelog ===
mathic (1.0~git20211001-1) unstable; urgency=medium

  * New upstream release (git snapshot).

 -- Doug Torrance <dtorrance@piedmont.edu>  Fri, 01 Oct 2021 05:30:15 -0400

mathic (1.0~git20200709-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/control
    - Bump Standards-Version to 4.6.0.

 -- Doug Torrance <dtorrance@piedmont.edu>  Wed, 18 Aug 2021 22:43:59 -0400

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                libgtest-dev,
                libmemtailor-dev,
                pkg-config
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/science-team/mathic
 Vcs-Git: https://salsa.debian.org/science-team/mathic.git
 Homepage: https://github.com/Macaulay2/mathic

## mathic 1.0~git20220218

=== src/CMakeLists.txt ===
if(CMAKE_BUILD_TYPE STREQUAL Debug)
  add_compile_options(-DMATHIC_DEBUG -DMEMT_DEBUG)
endif()

add_library(mathic STATIC
  mathic.h
  mathic.cpp
  mathic/Action.cpp
  mathic/Action.h
  mathic/BinaryKDTree.h
  mathic/BitTriangle.cpp
  mathic/BitTriangle.h
  mathic/BoolParameter.cpp
  mathic/BoolParameter.h
  mathic/CliParameter.cpp
  mathic/CliParameter.h
  mathic/CliParser.cpp
  mathic/CliParser.h
  mathic/ColumnPrinter.cpp
  mathic/ColumnPrinter.h
  mathic/DivMask.cpp
  mathic/DivMask.h
  mathic/HelpAction.cpp
  mathic/HelpAction.h
  mathic/IntegerParameter.cpp
  mathic/IntegerParameter.h
  mathic/StringParameter.cpp
  mathic/StringParameter.h
  mathic/Timer.cpp
  mathic/Timer.h
  mathic/display.cpp
  mathic/display.h
  mathic/error.cpp
  mathic/error.h
  mathic/stdinc.h
  )

target_link_libraries(mathic memtailor Threads::Threads)

target_include_directories(mathic PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  $<INSTALL_INTERFACE:include>
  )

include(CTest)
if(BUILD_TESTING)
  add_executable(mathic-unit-tests
    test/BitTriangle.cpp
    test/DivFinder.cpp
    test/HashTable.cpp
    test/PairQueue.cpp
    test/testMain.cpp
    )

  ################################
  # add gtest testing ############
  ################################
  if(NOT GTEST_FOUND)
    find_package(GTest)
  endif()
  include(GoogleTest)
  gtest_discover_tests(mathic-unit-tests TEST_PREFIX unit-tests:)

  if(GTEST_FOUND)
    target_link_libraries(mathic-unit-tests mathic GTest::GTest GTest::Main)
  else()
    include(FetchContent)
    FetchContent_Declare(googletest
      GIT_REPOSITORY https://github.com/google/googletest.git
      GIT_TAG        release-1.11.0
      )
    FetchContent_MakeAvailable(googletest)

    target_link_libraries(mathic-unit-tests mathic gtest)
    target_include_directories(mathic-unit-tests PRIVATE
      ${googletest_SOURCE_DIR}/googletest/include
      ${googletest_SOURCE_DIR}/googletest/src
      ${googletest_SOURCE_DIR}/googletest
      )
  endif()
endif()

=== debian/changelog ===
mathic (1.0~git20220218-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/control
    - Update Maintainer to Debian Math Team.
    - Update my email address (now a Debian Developer).
    - Update Vcs-* URL's (science-team -> math-team).
  * debian/copyright
   - Use leading spaces instead of tabs.
   - Add email addresses for upstream copyright holders.
   - Update my copyright years and email address.
  * debian/upstream/metadata
    - Add "---" for document start.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 23 Feb 2022 22:07:43 -0500

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: mathic
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Doug Torrance <dtorrance@piedmont.edu>
+Maintainer: Debian Math Team <team+math@tracker.debian.org>
+Uploaders: Doug Torrance <dtorrance@debian.org>
 Section: libs
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -8,8 +8,8 @@
                libmemtailor-dev,
                pkg-config
 Standards-Version: 4.6.0
-Vcs-Browser: https://salsa.debian.org/science-team/mathic
-Vcs-Git: https://salsa.debian.org/science-team/mathic.git
+Vcs-Browser: https://salsa.debian.org/math-team/mathic
+Vcs-Git: https://salsa.debian.org/math-team/mathic.git
 Homepage: https://github.com/Macaulay2/mathic
 Rules-Requires-Root: no

## mathic 1.0~git20220426

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

project(mathic VERSION 1.0 LANGUAGES CXX)

option(enable_pqsim "Build pqsim" OFF)
option(enable_divsim "Build divsim" OFF)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

find_package(Threads 2.1 REQUIRED QUIET)
find_package(Memtailor   REQUIRED)

add_library(memtailor STATIC IMPORTED)
set_target_properties(memtailor PROPERTIES
  IMPORTED_LOCATION             "${MEMTAILOR_LIBRARIES}"
  INTERFACE_INCLUDE_DIRECTORIES "${MEMTAILOR_INCLUDE_DIR}")

add_compile_options(
  -DPACKAGE_NAME="${PROJECT_NAME}"
  -DPACKAGE_TARNAME="${PROJECT_NAME}"
  -DPACKAGE_VERSION="${PROJECT_VERSION}"
  -DPACKAGE_STRING="${PROJECT_NAME} ${PROJECT_VERSION}"
  -DPACKAGE_BUGREPORT=""
  -DPACKAGE_URL=""
  -DPACKAGE="${PROJECT_NAME}"
  -Wall -Wextra -Wno-unused-parameter
  )

add_subdirectory(src)

set_target_properties(mathic PROPERTIES PUBLIC_HEADER src/mathic.h)

install(TARGETS mathic LIBRARY DESTINATION lib)
install(DIRECTORY src/mathic
  DESTINATION include
  FILES_MATCHING PATTERN "*.h"
  )
install(FILES README.md lgpl-2.0.txt lgpl-2.1.txt lgpl-3.0.txt
  DESTINATION licenses/mathic
  )

if(enable_pqsim)
add_executable(pqsim
  src/pqsim/pqMain.h         src/pqsim/pqMain.cpp
  src/pqsim/Item.h           src/pqsim/Item.cpp
  src/pqsim/Model.h          src/pqsim/Model.cpp
  src/pqsim/Simulator.h      src/pqsim/Simulator.cpp
  src/pqsim/GeobucketModel.h
  src/pqsim/HeapModel.h
  src/pqsim/StlSetModel.h
  src/pqsim/TourTreeModel.h
  src/pqsim/stdinc.h
  )
target_link_libraries(pqsim mathic)
endif()

if(enable_divsim)
add_executable(divsim
  src/divsim/divMain.h       src/divsim/divMain.cpp 
  src/divsim/Simulation.h    src/divsim/Simulation.cpp
  src/divsim/DivListModel.h
  src/divsim/KDTreeModel.h
  src/divsim/Monomial.h
  src/divsim/stdinc.h
  )
target_link_libraries(divsim mathic)
endif()

=== debian/changelog ===
mathic (1.0~git20220426-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/gbp.conf
    - New file; set debian-branch to debian/latest; recommended by DEP-14.

 -- Doug Torrance <dtorrance@debian.org>  Thu, 05 May 2022 07:39:22 -0400

## mathic 1.0~git20230916

=== debian/changelog ===
mathic (1.0~git20230916-1) unstable; urgency=medium

  * New upstream release (git snapshot)
  * debian/control
    - Bump Standards-Version to 4.6.2.
  * debian/copyright
    - Update my copyright years.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 20 Dec 2023 18:00:02 -0500

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                libgtest-dev,
                libmemtailor-dev,
                pkg-config
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/math-team/mathic
 Vcs-Git: https://salsa.debian.org/math-team/mathic.git
 Homepage: https://github.com/Macaulay2/mathic

## mathic 1.0~git20250513

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -67,7 +67,7 @@
     include(FetchContent)
     FetchContent_Declare(googletest
       GIT_REPOSITORY https://github.com/google/googletest.git
-      GIT_TAG        release-1.11.0
+      GIT_TAG        v1.16.0
       )
     FetchContent_MakeAvailable(googletest)

=== debian/changelog ===
mathic (1.0~git20250513-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/control
    - Bump Standards-Version to 4.7.2.
  * debian/copyright
    - Update my copyright years.
  * debian/patches/c++17.patch
    - New patch; bump C++ standard to C++17 for googletest.
  * debian/tests/unittest
    - Update now that we link against googletest instead of compiling it.

 -- Doug Torrance <dtorrance@debian.org>  Sun, 24 Aug 2025 17:56:56 -0400

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                libgtest-dev,
                libmemtailor-dev,
                pkg-config
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/math-team/mathic
 Vcs-Git: https://salsa.debian.org/math-team/mathic.git
 Homepage: https://github.com/Macaulay2/mathic

=== debian/tests/control ===
Tests: unittest
Depends: @, build-essential, libgtest-dev, libmemtailor-dev, pkg-config
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="mode=git, pretty=1.0~git%cd" \
https://github.com/Macaulay2/mathic HEAD

## mathic 1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
-project(mathic VERSION 1.0 LANGUAGES CXX)
+project(mathic VERSION 1.1 LANGUAGES CXX)
 
 option(enable_pqsim "Build pqsim" OFF)
 option(enable_divsim "Build divsim" OFF)

=== debian/changelog ===
mathic (1.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    - Update pkg-config -> pkgconf in Build-Depends.
    - Remove redundant Rules-Requires-Root field.
  * debian/copyright
    - Replace old physical Free Software Foundation address.
  * debian/patches/c++17.patch
    - Remove patch; applied upstream
  * debian/rules
    - Stop setting GTEST_PATH; no longer necessary.
  * debian/watch
    - Update now that upstream publishes tarballs on GitHub releases page.

 -- Doug Torrance <dtorrance@debian.org>  Fri, 12 Dec 2025 13:58:41 -0500

=== debian/control ===
--- 
+++ 
@@ -6,12 +6,11 @@
 Build-Depends: debhelper-compat (= 13),
                libgtest-dev,
                libmemtailor-dev,
-               pkg-config
+               pkgconf
 Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/math-team/mathic
 Vcs-Git: https://salsa.debian.org/math-team/mathic.git
 Homepage: https://github.com/Macaulay2/mathic
-Rules-Requires-Root: no
 
 Package: libmathic-dev
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --enable-shared

=== debian/watch ===
version=4
opts=searchmode=plain \
https://api.github.com/repos/Macaulay2/mathic/releases \
https://github.com/Macaulay2/mathic/releases/download/v.*/mathic-@ANY_VERSION@@ARCHIVE_EXT@

## mathic 1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
-project(mathic VERSION 1.1 LANGUAGES CXX)
+project(mathic VERSION 1.2 LANGUAGES CXX)
 
 option(enable_pqsim "Build pqsim" OFF)
 option(enable_divsim "Build divsim" OFF)

=== debian/changelog ===
mathic (1.2-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    - Remove Priority field; "optional" is now the default.
    - Bump Standards-Version to 4.7.3.
  * debian/copyright
    - Update my copyright years.
  * debian/watch
    - Update the URL regex with one that's less greedy.

 -- Doug Torrance <dtorrance@debian.org>  Tue, 03 Feb 2026 21:49:57 -0500

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,11 @@
 Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Doug Torrance <dtorrance@debian.org>
 Section: libs
-Priority: optional
 Build-Depends: debhelper-compat (= 13),
                libgtest-dev,
                libmemtailor-dev,
                pkgconf
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/math-team/mathic
 Vcs-Git: https://salsa.debian.org/math-team/mathic.git
 Homepage: https://github.com/Macaulay2/mathic

=== debian/watch ===
version=4
opts=searchmode=plain \
https://api.github.com/repos/Macaulay2/mathic/releases \
[^"]*/mathic-@ANY_VERSION@@ARCHIVE_EXT@
